<?php

/* ----------------------------------------------------------------------------------------------------------------
WARNING: Modifying the following code is strictly prohibited per the terms of your agreement with Clickcentive.com,
and any of its affiliate partners.  Failure to comply with the terms of agreement will result in the immediate 
termination of your account, and the forfeiture of any credits and/or commissions in your account.
---------------------------------------------------------------------------------------------------------------- */	
		
class ClickCentiveLinks extends ClickCentive
{
	/**
    * Stores Link Insert Data
    * @var array
	*/	
	var $_inserts = array();
	
	function ClickCentiveLinks() 
	{
		$this->_construct();
	}
	
	protected function _construct() 
	{
		$this->checkRequest();
		$this->registerActions();
	}
	
		
	/*
	 * Loads XML-RPC File If Request URL Matches ClickCentive Request URI
	 * @return null
	*/  	
	protected function checkRequest()
	{
		// First Check For XMLRPC Request
		$requestURI = explode('/', parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH));
		$scriptName = explode('/', $_SERVER['SCRIPT_NAME']);
		
		for ($i= 0;$i < sizeof($scriptName);$i++) {
			if ($requestURI[$i] == $scriptName[$i]) {
				unset($requestURI[$i]);
			}
		}
		$request = array_values(array_filter($requestURI));
		if(is_array($request) && $request[0] == 'cc.server.php') {
			require_once CLICKCENTIVE_DIR . 'cc.server.php';
			exit;
		}	
		
		if(!empty($_GET['cc_view_links'])) {
			global $wpdb;
			$links = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}clickcentive ORDER BY created ASC");
			echo '<pre>'; print_r($links); echo '</pre>'; exit;
		}			
				
		// Then Check For Link Tracking Hit
		//if(!empty($_REQUEST['cc_track_id'])) {
		//	$GLOBALS['wpdb']->query("UPDATE {$GLOBALS['wpdb']->prefix}clickcentive SET hits = hits + 1 WHERE link_id = '".abs($_POST['cc_track_id'])."'");
		//}
	}
	
	/*
	 * Registers WP Action and Filter Hooks
	 * @return null
	*/  	
	protected function registerActions()
	{
		add_filter('the_content', array(&$this, 'insertLinks'), 999999999999);
		add_action('shutdown', array(&$this, 'debugResults'), 999999999999);	
		
		//add_action('wp_footer', array(&$this, 'insertTrackingScript'), 20);	
	}	

	
	/*
	 * Replaces Purchased Keywords With Links
	 * @return string
	*/ 	
	public function insertLinks($content) 
	{		
		global $post, $wpdb;
		
		$links = $wpdb->get_results("SELECT link_id,keyword,target FROM {$wpdb->prefix}clickcentive WHERE post_id = {$post->ID} ORDER BY created ASC", ARRAY_A);
		
		if(!empty($_GET['cc_keyword'])) {
			if(!is_array($links)) $links = array();
			array_push($links, array('keyword' => $_GET['cc_keyword'], 'target' => 'http://test.com', 'link_id' => 'test'));
		}
		
		if($links != false && !empty($links))
		{
			// REMOVE WHITESPACES INSIDE TAGS
			$encoded = stripslashes(preg_replace("/(<[^>]*>)/ie","str_replace(' ','%_WS_%','$1')", $content));
			// MARK EXISTING LINKS
			$encoded = stripslashes(preg_replace("/(<[^>]*href=[^>]*>)([^<]+)(<[^>]*>)/ie","str_replace(' ','%_WS_%','$1%_LI_%$2%_LI_%$3')", $encoded));
	
			foreach($links as $link)
			{
				$search  = "/(^|[^a-zA-Z0-9\"\'@\$\%\/\+\-\_\#\=\@\&]){1}({$link['keyword']})([^a-zA-Z0-9\"\'\%\/\+\-\_\#\=\@\&]|$){1}/ie";
				$replace = "str_replace(' ','%_WS_%','$1<a href=\"{$link['target']}\" id=\"cc-{$link['link_id']}\" alt=\"{$link['keyword']}\" title=\"{$link['keyword']}\">%_LI_%$2%_LI_%</a>$3')";
				
				$encoded = preg_replace($search, $replace, $encoded, 1, $count);
				
				if($count == 1) {
					$encoded = stripslashes(str_replace(array('%_WS_%<', '>%_WS_%'), array(' <', '> '), $encoded));
					$link['result'] = 'Inserted';
					
					$this->_inserts[] = $link;
				}
				else $link['result'] = 'Failed';
				
			}
			$content = str_replace(array('%_WS_%','%_LI_%'), array(' ',''), $encoded);		
		}
		
		return $content;
	}	

	/*
	 * Places Javascript In Footer To Track Link Clicks
	 * @return null
	*/ 		
	public function insertTrackingScript()
	{
		if(empty($this->_inserts)) return;

		echo "\n";
		echo '<script type="text/javascript">function cc_track(){var xmlhttp;if(window.XMLHttpRequest) xmlhttp=new XMLHttpRequest();';
		echo 'else xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");xmlhttp.open("POST","'.site_url().'/cc_tracking.php",true);';
		echo 'xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");';
		echo 'xmlhttp.send("cc_track_id="+event.target.getAttribute("id").substr(3));}</script>';
		echo "\n\n";
	}	

	/*
	 * Places Link Insertion Results On Bottom Of Page
	 * @return null
	*/ 		
	public function debugResults()
	{
		if(empty($this->_inserts)) return;
		
		if(!empty($_GET['cc_debug']) && $_GET['cc_debug'] == '1') {
			echo "\n\n<!--------------------------------------------------\n";
			echo "  LINK INSERT RESULTS:";
			foreach($this->_inserts as $link) {
				echo "\n\n    KEYWORD  : " . $link['keyword'];
				echo "\n    LINK URL : " . $link['target'];
				echo "\n    LINK ID  : " . $link['link_id'];
				echo "\n    RESULT   : " . $link['result'];
			}
			echo "\n--------------------------------------------------->";
		}		
		
		foreach($this->_inserts as $link) {
			if($link->result !== 'Inserted' && $link['link_id'] != 'test') {
				$this->sendData('LinkFailed', array('ID' => $link['link_id']));
			}
		}		
	}
	
}

$CC_Links = new ClickCentiveLinks();

?>