<?php

require_once 'cc.ns.php';
if(!class_exists('nusoap_client')) die('Unable To Load NuSoap.');

if(empty($this)) {
	$path = dirname(__FILE__);
	if(false !== $pos = stripos($path, 'wp-content')) {
		$path = substr($path, 0, $pos) . 'wp-load.php';
		if(file_exists($path)) require_once $path;
	}
	if(empty($GLOBALS['CC_Links'])) die('ClickCentive Plugin is Not Active.');
}	

$server = new soap_server();
$server->configureWSDL('cc.server', 'urn:cc.server', CLICKCENTIVE_URL . 'cc.server.php');


$server->register(
	'ProcessRequests',							// Method Name
	array( 
		'security_key' => 'xsd:string', 		// Input Parameter	
		'action' => 'xsd:string', 				// Input Parameter			
		'links'  => 'tns:Request'				// Input Parameter	
	),	    		
	array(
		'return'  => 'tns:Return')				// Output Parameters
	, 			
	'urn:cc.server',							// Namespace
	'urn:cc.server#ProcessRequests',			// Soapaction
	'rpc',										// Style
	'encoded',									// Use
	'CC Request'							    // Documentation
);

$server->register(
	'CleanLinks',							    
	array(
		'security_key' => 'xsd:string', 
		'links' => 'xsd:string'
	),									  		
	array( 'return' => 'xsd:string'), 			
	'urn:cc.server',							
	'urn:cc.server#CleanLinks',					
	'rpc',										
	'encoded',									
	'CC Request'							    
); 

$server->register(
	'GetVersion',							    
	array(
		'security_key' => 'xsd:string', 
	),									  		
	array( 'return' => 'xsd:string'), 			
	'urn:cc.server',							
	'urn:cc.server#GetVersion',					
	'rpc',										
	'encoded',									
	'CC Request'							    
); 

$server->wsdl->addComplexType(
	'Request',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array( 'links' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:Link[]')
	),
	'tns:Link'
);
$server->wsdl->addComplexType(
	'Link',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'postid'  => array('name' => 'postid',  'type'=>  'xsd:int'),
		'keyword' => array('name' => 'keyword', 'type' => 'xsd:string'),
		'link'    => array('name' => 'link',    'type' => 'xsd:string')
	)
);
$server->wsdl->addComplexType(
	'Return',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'completed' => array('name' => 'completed', 'type' => 'SOAP-ENC:Array'),
		'failed' => array('name' => 'failed', 'type' => 'SOAP-ENC:Array'),
		'error' => array('name' => 'results', 'type' => 'xsd:string'),
	)
);

function ProcessRequests($security_key, $action, $links)
{
	if(get_option('clickcentive_security_key') != $security_key) {
		return array('error' => 'Invalid security key.');
	}
	
	if(!is_array($links) || empty($links)) { 
		return array('error' => 'Invalid request parameters.');
	}
	
	return $GLOBALS['CC_Links']->processLinks($action, $links);
}

function CleanLinks($security_key, $links)
{
	if(get_option('clickcentive_security_key') != $security_key) {
		return 'Invalid security key.';
	}
	
	$ids   = explode(',', $links);
	$links = array();
	
	foreach($ids as $key => $id) {
		$links[] += abs($id);
	}
	$links = implode(',',$links);

	global $wpdb;
	$wpdb->query("DELETE FROM {$wpdb->prefix}clickcentive WHERE link_id NOT IN($links)");
	
	return defined('CLICKCENTIVE_VERSION') ? CLICKCENTIVE_VERSION : get_option('clickcentive_version');
}

function GetVersion($security_key)
{
	if(get_option('clickcentive_security_key') != $security_key) {
		return 'Invalid security key.';
	}
	
	return defined('CLICKCENTIVE_VERSION') ? CLICKCENTIVE_VERSION : get_option('clickcentive_version');
}


// Use the request to (try to) invoke the service
$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';

$server->service($HTTP_RAW_POST_DATA);

?>